use strict;
use Finance::NikkeiQuote;
use Win32::OLE qw(with);
use Win32::OLE::Const 'Microsoft Excel';

#1. Ж25Ԃ̊擾
use constant CmpCode => 6758;
my $oCmp = Finance::NikkeiQuote->new(CmpCode);
my $sName = ($oCmp->getinfo)[0];
my $raStock = $oCmp->getrange25();

#2.ExcelN
my $oExcel = Win32::OLE->new('Excel.Application', 
                        sub { my($oEx) =@_; $oEx->Quit;})
                        or die "ExcelNł܂񂵂";

#3.WorkbookǉAΏۂ̃[NV[gI
my $oBook = $oExcel->Workbooks->Add;
my $oWkS = $oBook->Worksheets(1);

#4.^Cg̐ݒĩZɒlݒj
$oWkS->Cells(1,1)->{Value} = 'ŋ25Ԃ̊';
$oWkS->Cells(1,1)->Font->{Size} = 16;
my @aDate = localtime;
$oWkS->Cells(1,7)->{Value} = 
    (($aDate[5]+1900) . '/' . ($aDate[4]+1) . '/' . $aDate[3] . ' ' .
      $aDate[2]       . ':' . $aDate[1]     . ':' . $aDate[0]);
$oWkS->Cells(2,1)->{Value} = $sName;
$oWkS->Cells(2,1)->Font->{Size} = 14;

#5.f[^̐ݒ
#5.1 ͈͂w肵ĐݒiOɏւĂj
my @aRes = reverse(
            map { [$_->[0], $_->[5], $_->[1], $_->[2], $_->[3], $_->[4],]} @$raStock
            );
$oWkS->Range('A4:F28')->{Value} = \@aRes;

#5.2 ̐ݒil3̃J}ǉAt͌/ɐݒj
$oWkS->Range('B4:F28')->{NumberFormatLocal} = "#,##0";
$oWkS->Range('A4:A28')->{NumberFormatLocal} = "m/dd";

#5.3 ̕ݒ肷
$oWkS->Columns(1)->{ColumnWidth} = 5;
$oWkS->Columns("B:G")->AutoFit;

#5.4 r
foreach my $iBdr (xlEdgeLeft, xlEdgeTop, xlEdgeRight, xlEdgeBottom, 
                  xlInsideVertical, xlInsideHorizontal, ) {
    my $oBdr = $oWkS->Range('A3:F28')->Borders($iBdr);
    with($oBdr,
        Weight => xlThin,
        LineStyle => xlContinuous,
        ColorIndex => xlAutomatic,
    );
}

#6. \o̐ݒ
my $oTtl = $oWkS->Range('A3:F3');
$oTtl->{Value} = ['t', '', 'n l', ' l', ' l',  'I l',  ];
$oTtl->{HorizontalAlignment} = xlCenter;
$oTtl->Borders(xlEdgeBottom)->{LineStyle} = xlDouble;
with($oTtl->Interior, 
        ColorIndex => 15,
);

#7. Ot
#7.1 Otǉ
$oWkS->Range("A3:F28")->Select;
my $oGraph = $oBook->Charts->Add;
$oGraph->{ChartType} = xlStockVOHLC;
$oGraph->SetSourceData({Source =>$oWkS->Range("A3:F28"), 
                        PlotBy =>xlColumns});
$oGraph->Location({Where => xlLocationAsObject, 
                   Name => $oWkS->{Name} } );
$oExcel->ActiveChart->Axes(xlCategory, xlPrimary)->{CategoryType} = xlCategoryScale;
#7.2 _Ot̐Fς
with($oExcel->ActiveChart->SeriesCollection(1)->Interior, 
        ColorIndex => 8, Pattern => xlSolid,
    );
#7.3 傫ƈʒuύX
with ($oWkS->Shapes(1), 
    Width  => 600, Height => 300, Left   => 250, Top    =>  30,
);

#7.4 Ott@Cɏo
$oExcel->ActiveChart->Export( "c:\\temp\\ExGraph.png", "PNG", 1);

#8. Excelt@Cۑ
$oExcel->{DisplayAlerts}=undef;
my $iRes = $oBook->SaveAs( 'c:\\temp\\ExGraph.xls' );
unless($iRes) {
    print STDERR "t@C͏o͂ł܂ł\n";
    print STDERR Win32::OLE->LastError(), "\n";
    $oBook->{saved}=1;
}
$oExcel->{DisplayAlerts}=1;

#9. Еt
undef $oWkS;
undef $oBook;
undef $oExcel;
