use strict;
use Jcode;
use Finance::NikkeiQuote;
use GD::Graph::bars;
#TrueTypetHgEt@CiNTł'c:/WINNT/FONTS/MSGOTHIC.TTC'Ȃǁj
use constant TtfFontFile => '/usr/share/fonts/TrueType/tchagom.ttc';

#1. Ж25Ԃ̊擾
use constant CmpCode => 6758;
my $oCmp = Finance::NikkeiQuote->new(CmpCode);
my $sName = ($oCmp->getinfo)[0];
my $raStock = $oCmp->getrange25();

#2. f[^𕪉
my (@aLbl, @aDt4, @aVol);
foreach my $raData (@$raStock) {
    unshift @aLbl,  shift @$raData;     #o
    unshift @aVol,  pop @$raData;       #
    unshift @aDt4,  $raData;            #e퐔l
}

#3. _Ot̍쐬ij
#3.1 ݒ
my $oGraph = GD::Graph::bars->new(800, 400);
$oGraph->set_title_font(TtfFontFile, 12);
$oGraph->set( 
    bgclr       => 'white',
    transparent => 0,
    dclrs       => [ 'cyan' ],
    title       => jcode($sName)->utf8,
    boxclr      => 'lgray',
  );
#3.2 o
open(PNG, ">bars.png");
binmode(PNG);
eval {
    print PNG $oGraph->plot([\@aLbl, \@aVol])->png;
};
print STDERR "$@\n" , $oGraph->error, "\n" if($@);
close PNG;
